Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 1112)
@@ -2,7 +2,6 @@
 
 import java.io.File;
 import java.io.IOException;
-import java.io.Serializable;
 import java.lang.reflect.Field;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
@@ -23,9 +22,7 @@
 import org.txm.Toolbox;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
-import org.txm.objects.CorpusBuild;
 import org.txm.objects.Project;
-import org.txm.objects.Workspace;
 import org.txm.utils.logger.Log;
 
 // FIXME: At this moment, an empty list is created for children, to not return
@@ -115,19 +112,19 @@
 	 */
 	protected String lazyName;
 
-	protected void computeForTheVeryFirstTime() throws Exception {
-		if (!this.hasBeenComputedOnce) {
-			this.compute();
-		}
-	}
 
 	/**
-	 * The command preferences node qualifier.
+	 * Command preferences node path.
 	 */
-	protected String preferencesNodeQualifier;
+	protected String commandPreferencesNodePath;
 	//protected IEclipsePreferences preferencesNode;
 
 	/**
+	 * Parameters node path. Concatenation of the Project scope path + the result uuid
+	 */
+	protected String parametersNodePath;
+	
+	/**
 	 * If set, allows the command to notify its progress.
 	 */
 	protected IProgressMonitor monitor;
@@ -167,64 +164,89 @@
 	 * If a local node exist with the parent_uuid, the parent will be retrieved and this result will be added to it. 
 	 * @param uuid
 	 */
-	public TXMResult(String uuid) {
-		this(uuid, null);
+	public TXMResult(String parametersNodePath) {
+		this(parametersNodePath, null);
 	}
 
+	
+	
 	/**
 	 * Creates a new TXMResult, child of the specified parent.
-	 * If UUID is null, a new UUID is generated.
+	 * If the parameters node path is null, a new path is generated from the project root path ending by a new generated UUID.
 	 * 
 	 * @param uuid
 	 * @param parent
 	 */
-	public TXMResult(String uuid, TXMResult parent) {
+	public TXMResult(String parametersNodePath, TXMResult parent) {
 		if (parent == this) {
 			throw new IllegalArgumentException("A result can not be parent of itself.");
 		}
-		if (uuid == null)	{
-			uuid = createUUID() + "_" + this.getClass().getSimpleName();
+		if (parametersNodePath == null)	{
+			this.uniqueID = createUUID() + "_" + this.getClass().getSimpleName(); //$NON-NLS-1$
+			if(this.getProject() != null)	{
+				parametersNodePath = this.getProject().getParametersNodeRootPath();
+			}
+			this.parametersNodePath = parametersNodePath + this.uniqueID;
 		}
-		this.uniqueID = uuid;
+		else	{
+			try {
+				this.uniqueID = parametersNodePath.substring(parametersNodePath.lastIndexOf("/") + 1);
+			}
+			// FIXME: essentially for the UUID "ROOT" defined in the Workspace class, see if we can do in another way
+			catch (Exception e) {
+				this.uniqueID = parametersNodePath;
+			}
+			this.parametersNodePath = parametersNodePath;
+		}
 
+		Log.finest("TXMResult.TXMResult(): parameters node path: " + this.parametersNodePath);
+
+		
 		this.weight = 0;
 		this.visible = true;
 		if (parent != null) {
 			parent.addChild(this);
 		}
 
-
 		this.children = new ArrayList<TXMResult>(1);
-		//		Base binaryCorpus = this.getBinaryCorpus();
-		//		if (binaryCorpus != null && this.getClass() != Base.class) {
-		//			this.preferencesNode = binaryCorpus.getPreferenceScope().getNode(FrameworkUtil.getBundle(getClass()).getSymbolicName());
-		this.preferencesNodeQualifier = FrameworkUtil.getBundle(getClass()).getSymbolicName();
-		//		}
 
-		// always return false
-		// FIXME: Debug
-		// System.out.println("TXMResult.TXMResult(): default preferences node qualifier = "
-		// + this.preferencesNodeQualifier + ", class = " + getClass());
+		this.commandPreferencesNodePath = FrameworkUtil.getBundle(getClass()).getSymbolicName(); //$NON-NLS-1$
+//		if(parametersNodePath == null)	{
+//			//parametersNodeRootPath = "instance/"; //$NON-NLS-1$
+//			if(this.getProject() != null)	{
+//				parametersNodePath = "project/" + this.getProject().getName() + "/";
+//			}
+//		}
+//		String uuid = createUUID() + "_" + this.getClass().getSimpleName(); //$NON-NLS-1$
+		//this.parametersNodePath = parametersNodePath + this.uniqueID; //$NON-NLS-1$
+		Log.finest("TXMResult.TXMResult(): command preferences node path: " + this.commandPreferencesNodePath);
 
+		
+		
 		this.dirty = true;
 		this.persistable = false;
 		this.userPersistable = TBXPreferences.getInstance().getBoolean(TBXPreferences.AUTO_PERSISTENCE_ENABLED);
-		
 
+
 		// retrieving parent from UUID
-		String puuid = this.getStringParameterValue(TXMPreferences.PARENT_UUID);
-		if ( !("ROOT".equals(uuid)) && // search for parent only if uuid != "ROOT"
+		String parentUUID = this.getStringParameterValue(TXMPreferences.PARENT_UUID);
+		
+		System.out.println("TXMResult.TXMResult(): parent UUID = " + parentUUID);
+		
+		if (!("ROOT".equals(this.uniqueID)) && // search for parent only if UUID != "ROOT"
 				parent == null && 
-				uuid != null && 
-				!puuid.isEmpty()) {
-			Log.warning("Searching parent with UUID: " + puuid + "...");
-			TXMResult retrievedParent = TXMResult.getResult(puuid);
+				this.uniqueID != null && 
+				!parentUUID.isEmpty()) {
+			Log.warning("Searching parent with UUID: " + parentUUID + "...");
+			TXMResult retrievedParent = TXMResult.getResult(parentUUID);
 			if (retrievedParent != null) {
 				Log.warning("Parent retrieved from UUID: " + retrievedParent + ".");
 				retrievedParent.addChild(this);
-			} else {
-				Log.severe("Warning: no parent was found in workspace for uuid="+uniqueID+" and puuid="+puuid+" preferences="+this.dumpParameters());
-				TBXPreferences.delete(this);
+			}
+			else {
+				Log.severe("Warning: no parent was found in workspace for uuid=" + uniqueID + " and puuid=" + parentUUID + " preferences=" + this.dumpParameters());
+				// FIXME: commented for now
+				//TBXPreferences.delete(this);
 				return;
 			}
 		}
@@ -245,7 +267,7 @@
 			this.autoLoadParametersFromAnnotations(); // auto fill from Parameter annotations
 			this.loadParameters();  // subclasses manual settings
 		} catch (Exception e) {
-			System.out.println("Fail to load "+uniqueID+"result: "+e);
+			Log.severe("Fail to load " + uniqueID + "result: " + e);
 			Log.printStackTrace(e);
 		}
 		
@@ -280,7 +302,28 @@
 		return this.children.size() > 0;
 	}
 
+	
 	/**
+	 * Gets the preferences node path of the result command.
+	 * 
+	 * @return
+	 */
+	public String getCommandPreferencesNodePath() {
+		return this.commandPreferencesNodePath;
+	}
+
+	
+	public String[] getCommandPreferencesKeys() throws BackingStoreException {
+		return TXMPreferences.getCommandScopeKeys(this.commandPreferencesNodePath);
+	}
+
+	public String[] getDefaultPreferencesKeys() throws BackingStoreException {
+		return TXMPreferences.getDefaultScopeKeys(this.commandPreferencesNodePath);
+	}
+
+
+	
+	/**
 	 * Gets a current parameter specified by its annotation "key" attribute and its annotation "type" attribute.
 	 * @param key
 	 * @param parameterType
@@ -475,14 +518,14 @@
 
 		if(TXMPreferences.resultScopeNodeExists(this))	{
 			str.append("\nResult local node preferences\n"); //$NON-NLS-1$
-			str.append(TXMPreferences.getKeysAndValues(TXMPreferences.scope, this.getUUID()));
+			str.append(TXMPreferences.getKeysAndValues(this.getParametersNodePath()));
 		}
 
 		str.append("\nCommand preferences\n"); //$NON-NLS-1$
-		str.append(TXMPreferences.getKeysAndValues(TXMPreferences.scope, this.preferencesNodeQualifier));
+		str.append(TXMPreferences.getKeysAndValues(this.commandPreferencesNodePath));
 
 		str.append("\nDefault command preferences\n"); //$NON-NLS-1$
-		str.append(TXMPreferences.getKeysAndValues(DefaultScope.INSTANCE, this.preferencesNodeQualifier));
+		str.append(TXMPreferences.getKeysAndValues(DefaultScope.INSTANCE + "/" + this.commandPreferencesNodePath));
 
 
 
@@ -638,24 +681,7 @@
 		this.dirty = true;
 	}
 
-	/**
-	 * Gets the preferences node qualifier of the result command.
-	 * 
-	 * @return
-	 */
-	public String getPreferencesNodeQualifier() {
-		return this.preferencesNodeQualifier;
-	}
 
-	public String[] getCommandPreferencesKeys() throws BackingStoreException {
-		return TXMPreferences.getCommandScopeKeys(this.preferencesNodeQualifier);
-	}
-
-	public String[] getDefaultPreferencesKeys() throws BackingStoreException {
-		return TXMPreferences.getDefaultScopeKeys(this.preferencesNodeQualifier);
-	}
-
-
 	/**
 	 * Gets the value of the specified key in parameters, local result node or
 	 * default preferences nodes.
@@ -664,7 +690,7 @@
 	 * @return
 	 */
 	public int getIntParameterValue(String key) {
-		return TXMPreferences.getInt(key, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getInt(key, this, this.commandPreferencesNodePath);
 	}
 
 	/**
@@ -675,7 +701,7 @@
 	 * @return
 	 */
 	public float getFloatParameterValue(String key) {
-		return TXMPreferences.getFloat(key, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getFloat(key, this, this.commandPreferencesNodePath);
 	}
 
 	/**
@@ -686,7 +712,7 @@
 	 * @return
 	 */
 	public double getDoubleParameterValue(String key) {
-		return TXMPreferences.getDouble(key, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getDouble(key, this, this.commandPreferencesNodePath);
 	}
 
 	/**
@@ -697,7 +723,7 @@
 	 * @return
 	 */
 	public boolean getBooleanParameterValue(String key) {
-		return TXMPreferences.getBoolean(key, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getBoolean(key, this, this.commandPreferencesNodePath);
 	}
 
 	/**
@@ -708,7 +734,7 @@
 	 * @return
 	 */
 	public long getLongParameterValue(String key) {
-		return TXMPreferences.getLong(key, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getLong(key, this, this.commandPreferencesNodePath);
 	}
 
 	/**
@@ -719,7 +745,7 @@
 	 * @return
 	 */
 	public String getStringParameterValue(String key) {
-		return TXMPreferences.getString(key, this, this.preferencesNodeQualifier);
+		return TXMPreferences.getString(key, this, this.commandPreferencesNodePath);
 	}
 
 
@@ -767,9 +793,9 @@
 		}
 		this.saveParameter(TXMPreferences.LAZY_NAME, this.getSimpleName());	
 
-
+		this.saveParameter(TXMPreferences.RESULT_PARAMETERS_NODE_PATH, this.parametersNodePath);
 		this.saveParameter(TXMPreferences.RESULT_UUID, this.uniqueID);
-		this.saveParameter(TXMPreferences.BUNDLE_ID, this.preferencesNodeQualifier);
+		this.saveParameter(TXMPreferences.BUNDLE_ID, this.commandPreferencesNodePath);
 		if(this.parent != null)	{
 			this.saveParameter(TXMPreferences.PARENT_UUID, this.parent.getUUID());
 		}
@@ -885,7 +911,7 @@
 				f.set(this, value);
 
 				// FIXME: Debug
-				Log.finest("TXMResult.autoLoadParametersFromAnnotations(): setting parameter " + key + " = " + value + " for " + this.getClass());
+				Log.finest("TXMResult.autoLoadParametersFromAnnotations(): setting parameter " + key + " = " + value + "\t[" + this.getClass() + "]");
 
 			} catch (Exception e) {
 				e.printStackTrace();
@@ -1314,7 +1340,6 @@
 
 	/**
 	 * Gets the first parent of the specified class, eg. this.getFirstParent(Partition.class);
-	 * Returns the object itself if it is of the specified class.
 	 * @param type
 	 * @return
 	 */
@@ -1322,16 +1347,19 @@
 		TXMResult node = null;
 		TXMResult parent = this.parent;
 		do {
-			if(parent.getClass().equals(type)) {
-				node = parent;	
+			if(parent != null)	{
+				if(parent.getClass().equals(type)) {
+					node = parent;	
+				}
+	
+				parent = parent.getParent();
 			}
-
-			parent = parent.getParent();
 		} while (parent != null && node == null);
 
 		return node;
 	}
 
+	
 
 	//	/**
 	//	 * Gets the first parent of the specified class, eg. this.getFirstParent(Partition.class);
@@ -2019,7 +2047,19 @@
 		this.setUserPersistable(!this.userPersistable);
 	}
 	
+	/**
+	 * Gets the project of the result.
+	 * @return the project of the result
+	 */
 	public final Project getProject() {
 		return (Project) this.getFirstParent(Project.class);
 	}
+
+	/**
+	 * Gets the parameters node path.
+	 * @return the parametersNodePath
+	 */
+	public String getParametersNodePath() {
+		return parametersNodePath;
+	}
 }
Index: tmp/org.txm.core/src/java/org/txm/objects/Partition.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Partition.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/objects/Partition.java	(revision 1112)
@@ -30,20 +30,32 @@
 import org.txm.core.results.TXMResult;
 
 /**
- * Partition abstract representation
+ * Partition abstract representation.
  */
 public abstract class Partition extends TXMResult {
 
+	/**
+	 * 
+	 * @param parent
+	 */
 	public Partition(CorpusBuild parent) {
 		super(parent);
 		this.persistable = true;
 	}
 	
-	public Partition(String uuid) {
-		super(uuid);
+	/**
+	 * 
+	 * @param parametersNodePath
+	 */
+	public Partition(String parametersNodePath) {
+		super(parametersNodePath);
 		this.persistable = true;
 	}
 	
+	/**
+	 * 
+	 * @return
+	 */
 	public CorpusBuild getCorpus() {
 		return (CorpusBuild) this.getParent();
 	}
Index: tmp/org.txm.core/src/java/org/txm/objects/Text.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Text.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/objects/Text.java	(revision 1112)
@@ -73,12 +73,13 @@
 	 * @param corpus the base
 	 * @param text the text
 	 */
-	public Text(String uuid) {
-		super(uuid);
+	public Text(String parametersNodePath) {
+		super(parametersNodePath);
 		this.setVisible(false);
 		this.persistable = true;
 	}
 
+	
 	/* 
      * Retro compatiblity to load Editions from a XML Element 
 	 */
Index: tmp/org.txm.core/src/java/org/txm/objects/CorpusBuild.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/CorpusBuild.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/objects/CorpusBuild.java	(revision 1112)
@@ -154,8 +154,12 @@
 		this.persistable = true;
 	}
 
-	public CorpusBuild(String uuid) {
-		super(uuid);
+	/**
+	 * 
+	 * @param parametersNodePath
+	 */
+	public CorpusBuild(String parametersNodePath) {
+		super(parametersNodePath);
 		this.persistable = true;
 	}
 	
Index: tmp/org.txm.core/src/java/org/txm/objects/Edition.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Edition.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/objects/Edition.java	(revision 1112)
@@ -85,8 +85,8 @@
 	 *
 	 * @param text the text
 	 */
-	public Edition(String uuid) {
-		super(uuid);
+	public Edition(String parametersNodePath) {
+		super(parametersNodePath);
 		this.visible = false;
 		this.persistable = true;
 	}
Index: tmp/org.txm.core/src/java/org/txm/objects/EditionDefinition.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/EditionDefinition.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/objects/EditionDefinition.java	(revision 1112)
@@ -14,7 +14,7 @@
 	Preferences node;
 	
 	public EditionDefinition(Project project, String name) {
-		this.node = project.getPreferences().getNode(EditionDefinition.class.getSimpleName()).node(name);
+		this.node = project.getPreferencesScope().getNode(EditionDefinition.class.getSimpleName()).node(name);
 	}
 
 	public String getName() {
Index: tmp/org.txm.core/src/java/org/txm/objects/Project.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Project.java	(revision 1111)
+++ tmp/org.txm.core/src/java/org/txm/objects/Project.java	(revision 1112)
@@ -30,6 +30,7 @@
 
 import java.io.File;
 import java.io.IOException;
+import java.lang.reflect.Constructor;
 import java.util.ArrayList;
 import java.util.Date;
 import java.util.HashMap;
@@ -47,7 +48,9 @@
 import org.eclipse.core.runtime.IPath;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.Path;
+import org.eclipse.core.runtime.Platform;
 import org.eclipse.core.runtime.preferences.IEclipsePreferences;
+import org.osgi.framework.Bundle;
 import org.osgi.service.prefs.BackingStoreException;
 import org.osgi.service.prefs.Preferences;
 import org.txm.Toolbox;
@@ -55,10 +58,12 @@
 import org.txm.core.engines.ImportEngines;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TBXPreferences;
+import org.txm.core.preferences.TXMPreferences;
 import org.txm.core.results.Parameter;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
 import org.txm.stat.utils.ConsoleProgressBar;
+import org.txm.utils.logger.Log;
 import org.txm.utils.zip.Zip;
 import org.w3c.dom.Element;
 import org.xml.sax.SAXException;
@@ -120,10 +125,11 @@
 	private Date pCreationDate;
 
 	/**
-	 * Instantiates a new base.
-	 *
-	 * @param project the project
-	 * @throws Exception 
+	 * Instantiates a new project.
+	 * 
+	 * @param workspace
+	 * @param name
+	 * @throws Exception
 	 */
 	public Project(Workspace workspace, String name) throws Exception {
 		super(workspace);
@@ -135,6 +141,37 @@
 		initRCPStuffs();
 	}
 
+	/**
+	 * 
+	 * @param nodePath
+	 * @throws CoreException
+	 */
+	public Project(String parametersNodePath) throws CoreException {
+		super(parametersNodePath);
+		initRCPStuffs();
+		
+		this.dirty = false;
+		this.hasBeenComputedOnce = true;
+		//		
+		//		this.setPath(project.getPath() + getName());
+		//		params = parameters;
+		//		setSelfElement(params.root);
+		//		this.project = project;
+		//		//load();
+		//		this.pName = params.name;
+		//		if (!pName.equals(pName.toUpperCase())) {
+		//			System.out.println("Warning in Base.init: binary corpus name contains lower case letters: "+this.pName);
+		//		}
+		//		
+		//		this.scope = new BasePreferenceScope(this);
+		
+		
+		// loading corpus
+		this.loadResults();
+		
+	}
+
+	
 	private void initRCPStuffs() throws CoreException {
 		IWorkspace rcpWorkspace = ResourcesPlugin.getWorkspace();
 		if (this.rcpProject == null) {
@@ -170,25 +207,69 @@
 		}
 	}
 
-	public Project(String uuid) throws CoreException {
-		super(uuid);
-		initRCPStuffs();
+	/**
+	 * Loads and create the persisted results from the preferences service.
+	 */
+	protected void loadResults()	{
+		//		if (TBXPreferences.getInstance().getBoolean(TBXPreferences.AUTO_PERSISTENCE_ENABLED)) {
+		Log.finest("*** Project.loadResults(): reloading persitent results...");
 		
-		this.dirty = false;
-		this.hasBeenComputedOnce = true;
-		//		
-		//		this.setPath(project.getPath() + getName());
-		//		params = parameters;
-		//		setSelfElement(params.root);
-		//		this.project = project;
-		//		//load();
-		//		this.pName = params.name;
-		//		if (!pName.equals(pName.toUpperCase())) {
-		//			System.out.println("Warning in Base.init: binary corpus name contains lower case letters: "+this.pName);
-		//		}
-		//		
-		//		this.scope = new BasePreferenceScope(this);
+		IWorkspace rcpWorkspace = ResourcesPlugin.getWorkspace();
+	//	IProject projects[] = rcpWorkspace.getRoot().getProjects();
+		
+//		Log.info("Toolbox.initialize(): " + projects.length + " project(s) found in workspace.");
+		
+			ArrayList<String> resultNodePaths = TXMPreferences.getAllResultsNodePaths(this.getParametersNodeRootPath());
+			
+			Log.info("Project.loadResults(): loading " + resultNodePaths.size() + " result(s) from project " + this.getName() + "...");
+
+			for (String parametersNodePath : resultNodePaths) {
+
+				// skip non-TXMResult preference node
+//				if (TXMPreferences.getString(TXMPreferences.BUNDLE_ID, nodeQualifier).isEmpty())	{
+//					continue;
+//				}
+
+				try {
+					
+					String className = TXMPreferences.preferencesRootNode.node(parametersNodePath).get("class", ""); //$NON-NLS-1$
+
+					// Skip Project object
+					if(className.equals(Project.class.getName()))	{
+						continue;
+					}
+
+					Log.finest("\nProject.loadResults(): loading from result node qualifier " + parametersNodePath);
+					//Log.finest("Toolbox.initialize(): class = " + TXMPreferences.getString("class", nodeQualifier));
+					//TXMPreferences.dump();
+
+					
+					Log.finest("Project.loadResults(): class = " + className); //$NON-NLS-1$
+//					Log.finest("Toolbox.initialize(): parent_uuid = " + TXMPreferences.getString(TXMPreferences.PARENT_UUID, nodeQualifier));
+					Log.finest("Project.loadResults(): parent_uuid = " + TXMPreferences.preferencesRootNode.node(parametersNodePath).get(TXMPreferences.PARENT_UUID, "")); //$NON-NLS-1$
+					String bundleId = TXMPreferences.preferencesRootNode.node(parametersNodePath).get(TXMPreferences.BUNDLE_ID, ""); //$NON-NLS-1$
+					Log.finest("Project.loadResults(): bundle_id = " + bundleId); //$NON-NLS-1$
+					Bundle bundle = Platform.getBundle(bundleId);
+					if (bundle == null) {
+						Log.finest("Warning: can not restore object with bundle name " + bundleId); //$NON-NLS-1$
+						continue;
+					}
+					
+					Class<?> cl = bundle.loadClass(className);
+					Constructor<?> cons = cl.getConstructor(String.class);
+					TXMResult result = (TXMResult) cons.newInstance(parametersNodePath);
+					
+					// not an internal persistence (eg. corpus or partition)
+					if (!result.isPersistable())	{
+						result.setUserPersistable(true);	
+					}
+				} catch (Exception e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
 	}
+	
 
 	//	public BasePreferenceScope getPreferenceScope() {
 	//		return scope;
@@ -710,7 +791,7 @@
 
 	public boolean save() {
 		//System.out.println("SAVE PROJECT PREFERENSCOPE");
-		if (this.getPreferences() != null) {
+		if (this.getPreferencesScope() != null) {
 			//	this.rcpProject.
 		}
 		return true;
@@ -801,11 +882,11 @@
 	}
 
 	public void setXsltParameter(String name, String value) {
-		this.getPreferences().getNode("xsl").node(TBXPreferences.FRONT_XSL_PARAMETERS).put(name, value);
+		this.getPreferencesScope().getNode("xsl").node(TBXPreferences.FRONT_XSL_PARAMETERS).put(name, value);
 	}
 
 	public HashMap<String, String> getXsltParameters() {
-		Preferences params = this.getPreferences().getNode("xsl").node(TBXPreferences.FRONT_XSL_PARAMETERS);
+		Preferences params = this.getPreferencesScope().getNode("xsl").node(TBXPreferences.FRONT_XSL_PARAMETERS);
 		HashMap<String, String> hparams = new HashMap<>();
 		try {
 			for (String k : params.childrenNames()) {
@@ -819,15 +900,15 @@
 	}
 
 	public void removeXsltParameter(String name) {
-		this.getPreferences().getNode("xsl").node(TBXPreferences.FRONT_XSL_PARAMETERS).remove(name);
+		this.getPreferencesScope().getNode("xsl").node(TBXPreferences.FRONT_XSL_PARAMETERS).remove(name);
 	}
 
 	public String getFrontXSL() {
-		return this.getPreferences().getNode("xsl").get(TBXPreferences.FRONT_XSL, null);
+		return this.getPreferencesScope().getNode("xsl").get(TBXPreferences.FRONT_XSL, null);
 	}
 
 	public void setXslt(String xslpath) {
-		this.getPreferences().getNode("xsl").put(TBXPreferences.FRONT_XSL, xslpath);
+		this.getPreferencesScope().getNode("xsl").put(TBXPreferences.FRONT_XSL, xslpath);
 	}
 
 	public void setAnnotate(boolean b) {
@@ -847,17 +928,17 @@
 	}
 
 	public void addTokenizerParameter(String name, String value) {
-		IEclipsePreferences params = this.getPreferences().getNode("Tokenizer");
+		IEclipsePreferences params = this.getPreferencesScope().getNode("Tokenizer");
 		params.put(name, value);
 	}
 	
 	public String getTokenizerParameter(String name, String defaultvalue) {
-		IEclipsePreferences params = this.getPreferences().getNode("Tokenizer");
+		IEclipsePreferences params = this.getPreferencesScope().getNode("Tokenizer");
 		return params.get(name, defaultvalue);
 	}
 	
 	public boolean getDoTokenizerStep() {
-		IEclipsePreferences params = this.getPreferences().getNode("Tokenizer");
+		IEclipsePreferences params = this.getPreferencesScope().getNode("Tokenizer");
 		return params.getBoolean("doTokenizeStep", true);
 	}
 
@@ -865,7 +946,7 @@
 		return new EditionDefinition(this, name);
 	}
 
-	public ProjectScope getPreferences() {
+	public ProjectScope getPreferencesScope() {
 		return this.preferenceScope;
 	}
 
@@ -897,11 +978,20 @@
 
 	public boolean hasEditionDefinition(String name) {
 		try {
-			return getPreferences().getNode("EditionDefinition").nodeExists(name);
+			return getPreferencesScope().getNode("EditionDefinition").nodeExists(name);
 		} catch (BackingStoreException e) {
 			// TODO Auto-generated catch block
 			e.printStackTrace();
 			return false;
 		}
 	}
+	
+	/**
+	 * Gets the project parameters root path ("project/[project name]/")
+	 * @return
+	 */
+	public String getParametersNodeRootPath()	{
+		return "project/" + this.rcpProject.getName() + "/";
+	}
+	
 }
Index: tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java
===================================================================
--- tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 1111)
+++ tmp/org.txm.chartsengine.core/src/org/txm/chartsengine/core/results/ChartResult.java	(revision 1112)
@@ -111,10 +111,10 @@
 	/**
 	 * Creates a new ChartResult with no parent.
 	 * If a local node exist with the parent_uuid, the parent will be retrieved and this result will be added to it. 
-	 * @param uuid
+	 * @param parametersNodePath
 	 */
-	public ChartResult(String uuid) {
-		this(uuid, null);
+	public ChartResult(String parametersNodePath) {
+		this(parametersNodePath, null);
 	}
 	
 	/**
@@ -122,8 +122,8 @@
 	 * @param uuid
 	 * @param parent
 	 */
-	public ChartResult(String uuid, TXMResult parent) {
-		super(uuid, parent);
+	public ChartResult(String parametersNodePath, TXMResult parent) {
+		super(parametersNodePath, parent);
 		this.chartsEngine = ChartsEngine.getCurrent();
 		this.chartDirty = true;
 		this.needsToResetView = false;
@@ -520,7 +520,7 @@
 	 * @return
 	 */
 	public boolean isEmptyPreference(String key)	{
-		return TXMPreferences.isEmpty(this.preferencesNodeQualifier, key);
+		return TXMPreferences.isEmpty(this.commandPreferencesNodePath, key);
 	}
 
 	
Index: tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java
===================================================================
--- tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 1111)
+++ tmp/org.txm.concordance.core/src/org/txm/concordance/core/functions/Concordance.java	(revision 1112)
@@ -183,10 +183,10 @@
 
 	/**
 	 * 
-	 * @param uuid
+	 * @param parametersNodePath
 	 */
-	public Concordance(String uuid)	{
-		super(uuid);
+	public Concordance(String parametersNodePath)	{
+		super(parametersNodePath);
 	}
 	
 
Index: tmp/org.txm.ahc.core/src/org/txm/ahc/core/functions/AHC.java
===================================================================
--- tmp/org.txm.ahc.core/src/org/txm/ahc/core/functions/AHC.java	(revision 1111)
+++ tmp/org.txm.ahc.core/src/org/txm/ahc/core/functions/AHC.java	(revision 1112)
@@ -154,8 +154,8 @@
 	 * @param numberOfClusters the n cluster
 	 * @param display2D the display mode
 	 */
-	public AHC(String uuid)	{
-		this(uuid, null);
+	public AHC(String parametersNodePath)	{
+		this(parametersNodePath, null);
 	}
 	
 	/**
@@ -182,8 +182,8 @@
 	 * @param numberOfClusters the n cluster
 	 * @param display2D the display mode
 	 */
-	public AHC(String uuid, CA ca)	{
-		super(uuid, ca);
+	public AHC(String parametersNodePath, CA ca)	{
+		super(parametersNodePath, ca);
 	}
 
 	@Override
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/debug/TXMResultDebugView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/debug/TXMResultDebugView.java	(revision 1111)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/debug/TXMResultDebugView.java	(revision 1112)
@@ -104,6 +104,7 @@
 		StringBuffer buffer = new StringBuffer();
 		buffer.append("Class: " + this.currentResult.getClass() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("UUID: " + this.currentResult.getUUID() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+		buffer.append("Node path: " + this.currentResult.getParametersNodePath() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("Simple name: " + this.currentResult.getSimpleName() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("User name: " + this.currentResult.getUserName() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("Lazy name: " + this.currentResult.getLazyName() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/UpdateCorpus.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/UpdateCorpus.java	(revision 1111)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/UpdateCorpus.java	(revision 1112)
@@ -47,9 +47,9 @@
 			System.out.println("Can't update a corpus not imprted with XTZ import module.");
 			return null;
 		}
-		project.getPreferences().getNode("import").put(ImportKeys.MULTITHREAD, "false"); //too soon
-		project.getPreferences().getNode("import").putBoolean(ImportKeys.DEBUG, Log.getLevel().intValue() < Level.WARNING.intValue()); // need debug for experimental stuff
-		project.getPreferences().getNode("import").put(ImportKeys.UPDATECORPUS, "true");
+		project.getPreferencesScope().getNode("import").put(ImportKeys.MULTITHREAD, "false"); //too soon
+		project.getPreferencesScope().getNode("import").putBoolean(ImportKeys.DEBUG, Log.getLevel().intValue() < Level.WARNING.intValue()); // need debug for experimental stuff
+		project.getPreferencesScope().getNode("import").put(ImportKeys.UPDATECORPUS, "true");
 		
 //		String txmhome = Toolbox.getTxmHomePath();
 //		File scriptDir = new File(txmhome, "scripts/groovy/user/org/txm/scripts/importer/xtz");
